Linux
- POST
- /workspaces
- /:workspace
- /projects
- /:project_name
- /pipelines
- /:pipeline_id
- /actions
Creates a new Linux action in the pipeline
Request
REQUIRED SCOPES
EXECUTION_MANAGE
URL PARAMETERS
workspacerequiredstring
The human-readable ID of the workspaceExample: "my-company"
project_namerequiredstring
The human-readable ID of the projectExample: "my-project"
pipeline_idrequiredinteger
The ID of the pipelineExample: 123
POST PARAMETERS
typerequiredstring enum
The type of the actionAllowed enum:
NATIVE_BUILD_LINUXurlread-onlystring
API endpoint to GET this objecthtml_urlread-onlystring
Web URL to view this object in Buddy.worksafter_action_idinteger
The numerical ID of the action, after which this action should be addednamerequiredstring
The name of the actiontrigger_timestring enum
Specifies when the action should be executedAllowed enum:
ON_EVERY_EXECUTION,ON_SUCCESS,ON_FAILURE,ON_BACK_TO_SUCCESS,ON_WARNING,ON_WAIT_FOR_APPROVE,ON_TERMINATEtrigger_conditionsTriggerConditionView[]
The list of trigger conditions to meet so that the action can be triggeredrun_nextstring enum
Defines whether the action should run in parallel with the next oneAllowed enum:
WAIT_ON_SUCCESS,IN_SOFT_PARALLEL,IN_HARD_PARALLELrun_only_on_first_failureboolean
Defines whether the action should be executed on each failure. Restricted to and required if the trigger_time is ON_FAILUREvariablesEnvironmentVariableView[]
The list of variables you can use the actiondisabledboolean
When set to true the action is disabled. By default it is set to falsetimeoutinteger
The timeout in secondsignore_errorsboolean
If set to true the execution will proceed, mark action as a warning and jump to the next action. Doesn't apply to deployment actionsretry_countinteger
Number of retries if the action failsretry_intervalinteger
Delay time between auto retries in secondsloopstring[]
The list of commands that will be executed in a loopcurrent_revisionstring
The git revision of the last successful run of the actionpermissionsPermissionsView
Access permissions configurationworking_directorystring
The directory in which the pipeline filesystem will be mountedexecute_every_commandboolean
If set to true all commands will be executed regardless of the result of the previous commandcommandsstring[]
The commands to execute in the native build environmentdeployment_excludesstring[]
The list of files or directories to exclude from deploymentvm_from_prev_actionboolean
If set to true, the VM from the previous action will be usedvm_action_idinteger
The ID of the action from which the VM will be usedvm_action_namestring
The name of the action from which the VM will be usedinstance_typestring enum
The type of instance to use for the native buildAllowed enum:
GENERAL_MEDIUM,GENERAL_LARGE,GENERAL_XLARGE,GENERAL_2XLARGE,COMPUTE_MEDIUM,COMPUTE_LARGE,COMPUTE_XLARGE,COMPUTE_2XLARGE,ARM_GENERAL_MEDIUM,ARM_GENERAL_LARGE,ARM_GENERAL_XLARGE,ARM_GENERAL_2XLARGE,ARM_COMPUTE_MEDIUM,ARM_COMPUTE_LARGE,ARM_COMPUTE_XLARGE,ARM_COMPUTE_2XLARGEsync_pathsSyncPathView[]
Define file paths that should be copied before (PIPELINE_TO_VM) and after the execution (VM_TO_PIPELINE).shellstring enum
The name of the shell that will be used to execute commandsAllowed enum:
SH,BASH,POWERSHELLdistributionstring enum
Defines the image used to create the VMAllowed enum:
UBUNTU_20_04,AMI,WINDOWS_SERVER_2019,PREVIOUS_ACTIONamiAmiView
Set if distribution is set to AMI.Response
RESPONSE BODY
typestring enum
The type of the actionAllowed enum:
NATIVE_BUILD_LINUXurlread-onlystring
API endpoint to GET this objecthtml_urlread-onlystring
Web URL to view this object in Buddy.worksidinteger
The ID of the actionnamestring
The name of the actioncurrent_revisionstring
The git revision of the last successful run of the actiontrigger_timestring enum
Specifies when the action should be executedAllowed enum:
ON_EVERY_EXECUTION,ON_SUCCESS,ON_FAILURE,ON_BACK_TO_SUCCESS,ON_WARNING,ON_WAIT_FOR_APPROVE,ON_TERMINATEtrigger_conditionsTriggerConditionView[]
The list of trigger conditions to meet so that the action can be triggeredrun_nextstring enum
Defines whether the action should run in parallel with the next oneAllowed enum:
WAIT_ON_SUCCESS,IN_SOFT_PARALLEL,IN_HARD_PARALLELrun_only_on_first_failureboolean
Defines whether the action should be executed on each failure. Restricted to and required if the trigger_time is ON_FAILUREvariablesEnvironmentVariableView[]
The list of variables you can use the actiondisabledboolean
When set to true the action is disabled. By default it is set to falsetimeoutinteger
The timeout in secondsignore_errorsboolean
If set to true the execution will proceed, mark action as a warning and jump to the next action. Doesn't apply to deployment actionsretry_countinteger
Number of retries if the action failsretry_intervalinteger
Delay time between auto retries in secondslast_execution_statusstring enum
The status of the last run of the actionAllowed enum:
INPROGRESS,ENQUEUED,TERMINATED,SUCCESSFUL,FAILED,INITIAL,NOT_EXECUTED,SKIPPED,TERMINATING,WAITING_FOR_APPLY,WAITING_FOR_VARIABLES,WAITING_FOR_SETTABLE_VARIABLES,WAITING_FOR_VT_SESSIONpipelineShortPipelineView
Short representation of a pipelinepermissionsPermissionsView
Access permissions configurationloopstring[]
The list of commands that will be executed in a loopworking_directorystring
The directory in which the pipeline filesystem will be mountedexecute_every_commandboolean
If set to true all commands will be executed regardless of the result of the previous commandcommandsstring[]
The commands to execute in the native build environmentdeployment_excludesstring[]
The list of files or directories to exclude from deploymentvm_from_prev_actionboolean
If set to true, the VM from the previous action will be usedvm_action_idinteger
The ID of the action from which the VM will be usedvm_action_namestring
The name of the action from which the VM will be usedinstance_typestring enum
The type of instance to use for the native buildAllowed enum:
GENERAL_MEDIUM,GENERAL_LARGE,GENERAL_XLARGE,GENERAL_2XLARGE,COMPUTE_MEDIUM,COMPUTE_LARGE,COMPUTE_XLARGE,COMPUTE_2XLARGE,ARM_GENERAL_MEDIUM,ARM_GENERAL_LARGE,ARM_GENERAL_XLARGE,ARM_GENERAL_2XLARGE,ARM_COMPUTE_MEDIUM,ARM_COMPUTE_LARGE,ARM_COMPUTE_XLARGE,ARM_COMPUTE_2XLARGEsync_pathsSyncPathView[]
Define file paths that should be copied before (PIPELINE_TO_VM) and after the execution (VM_TO_PIPELINE).shellstring enum
The name of the shell that will be used to execute commandsAllowed enum:
SH,BASH,POWERSHELLdistributionstring enum
Defines the image used to create the VMAllowed enum:
UBUNTU_20_04,AMI,WINDOWS_SERVER_2019,PREVIOUS_ACTIONamiAmiView
Set if distribution is set to AMI.Last modified on Mar 18, 2026
Request example
curl -X POST "https://api.buddy.works/workspaces/:workspace/projects/:project_name/pipelines/:pipeline_id/actions" \
-H "Authorization: Bearer <YOUR-TOKEN>" \
-H "Content-Type: application/json" \
-d '{
"name": "Build application",
"type": "NATIVE_BUILD_LINUX",
"trigger_time": "ON_EVERY_EXECUTION",
"working_directory": "/home/ubuntu/build",
"commands": [
"ls -al"
],
"distribution": "AMI",
"ami": {
"id": "ami-00bf6b81ba0081ada",
"user": "ubuntu",
"port": "22"
},
"sync_paths": [
{
"pipeline_path": "/",
"vm_path": "/home/ubuntu/build",
"direction": "PIPELINE_TO_VM",
"excludes": "/.git"
},
{
"pipeline_path": "/",
"vm_path": "/home/ubuntu/build",
"direction": "VM_TO_PIPELINE",
"excludes": ""
}
]
}'STATUS200 OK